def count_instructions(ida)
	opcodes = Hash.new
	total = 0

	for fnr in (0 .. ida.get_func_qty() - 1)
		func = ida.getn_func(fnr)
		
		for addr in (func.startEA .. func.endEA - 1)
			flags = ida.getFlags(addr)
			
			if ida.isHead(flags) and ida.isCode(flags)
				line = ida.tag_remove(ida.generate_disasm_line(addr))
				
				if line.include?("  ")
					opcode = line[/(.*?)  /]
					opcode = opcode[0 .. opcode.length - 3]
				else
					opcode = line
				end
				
				if opcodes.has_key?(opcode)
					opcodes[opcode] = opcodes[opcode] + 1
				else
					opcodes[opcode] = 1
				end
				
				total = total + 1
			end
		end
	end
	
	return total, opcodes
end