require 'plugins/ictr'
require 'idarub'

ida, = IdaRub.auto_client

ida.print "Starting\n"

total, opcodes = count_instructions(ida)

ida.print "Done\n"

filename = ida.askfile_c(1, "*.*", "Save result to...")

if filename != nil
	file = File.new(filename, "w")
	sorted = opcodes.sort {|a, b| b[1]<=>a[1]}
	file.write(sprintf "Opcode distribution of file: %s\n", ida.get_input_file_path())
	file.write(sprintf "Total number of opcodes: %i\n\n", total)
	
	sorted.each_with_index {|o, i|
		file.write (sprintf "%04i. %06i %8.2f%%      %s\n", i+1, o[1], 100.0 * o[1] / total, o[0])
	}
	
	file.close
end

